"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = require("react");
var strictEquals = function (prev, next) { return prev === next; };
function usePreviousDistinct(value, compare) {
    if (compare === void 0) { compare = strictEquals; }
    var prevRef = react_1.useRef();
    var curRef = react_1.useRef(value);
    var firstRender = react_1.useRef(true);
    if (firstRender.current) {
        firstRender.current = false;
    }
    else if (!compare(curRef.current, value)) {
        prevRef.current = curRef.current;
        curRef.current = value;
    }
    return prevRef.current;
}
exports.default = usePreviousDistinct;
